/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                       *
 *                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "maschinenauswahl.h"

#include <qfile.h>
#include <qcombobox.h>
#include <qdatastream.h>

#include "historydoubleinput.h"
#include <kmessagebox.h>
#include <knuminput.h>


MaschinenAuswahl::MaschinenAuswahl ( QWidget *parent ) : MAuswahl ( parent )
	{
	maschinendatei = "maschinen.dat";
	MCHOSEN = FALSE;

	QFile f2 ( maschinendatei );
	if ( f2.open ( IO_ReadOnly ) )
		{
		QDataStream str ( &f2 );
		int i = 0;
		while ( ! str.atEnd() )
			{
			f2.at ( i * 128 );
			str >> name >> spx >> spy >> spz >> vx >> vy >> vz >> wx >> wy >> wz >> op >> mf >> a >> sdat >> wdat;
			auswahl->insertItem ( QString ( name ), -1 );
			i++;
			}
		aM = 0;
		auswahl->setCurrentItem ( aM );
		}
	f2.close();
	}

MaschinenAuswahl::~MaschinenAuswahl()
	{
	}

void MaschinenAuswahl::maschine_changed()
	{
	QFile f2 ( maschinendatei );
	if ( f2.open ( IO_ReadOnly ) )
		{
		QDataStream str ( &f2 );
		aM = auswahl->currentItem();
		f2.at ( aM * 128 );
		str >> name >> spx >> spy >> spz >> vx >> vy >> vz >> wx >> wy >> wz >> op >> mf >> a >> sdat >> wdat;
		}
	f2.close();

	if ( vx > vy )
		{
		if ( vx > vz )
			v_max = vx;
		else
			v_max = vz;

		if ( vy > vz )
			v_min = vz;
		else
			v_min = vy;
		}
	else
		{
		if ( vy > vz )
			v_max = vy;
		else
			v_max = vz;

		if ( vx > vz )
			v_min = vz;
		else
			v_min = vx;
		}

	if ( wx > wy )
		{
		if ( wy > wz )
			s_min = wz;
		else
			s_min = wy;

		if ( wx > wz )
			s_max = wx;
		else
			s_max = wz;
		}
	else
		{
		if ( wx > wz )
			s_min = wz;
		else
			s_min = wx;

		if ( wy > wz )
			s_max = wy;
		else
			s_max = wz;
		}

	schlicht_vorschub->setMaxValue ( v_min );
	eintauch_vorschub->setMaxValue ( vz );
	vs_schlichten = schlicht_vorschub->value();
	vs_eintauchen = eintauch_vorschub->value();
	}

void MaschinenAuswahl::vs_schlichten_changed()
	{
	vs_schlichten = schlicht_vorschub->value();
	}

void MaschinenAuswahl::vs_eintauchen_changed()
	{
	vs_eintauchen = eintauch_vorschub->value();
	}

void MaschinenAuswahl::ok_clicked()
	{
	MCHOSEN = TRUE;
	maschine_changed();
	close();
	}





