/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _PCNCVIEW_H_
#define _PCNCVIEW_H_

#include <qwidget.h>
#include <qevent.h>
#include <qprocess.h>
#include <kprocess.h>
#include <kprocess.h>

#include "m3dansicht.h"
#include "bohrung.h"
#include "bohrloch_fasen.h"
#include "bohrloch_versenken.h"
#include "topfloch.h"
#include "zylinder.h"
#include "tasche.h"
#include "quader.h"
#include "gewinde.h"
#include "text.h"
#include "wechselpos.h"
#include "wwechsel.h"
#include "wwechsel1.h"
#include "awwahl.h"
#include "werkzeugwechsel.h"
#include "maschinenauswahl.h"
#include "linie.h"
#include "liniex.h"
#include "liniey.h"
#include "liniez.h"
#include "kreis.h"
#include "vorschub.h"
#include "schleife.h"
#include "spiel.h"
#include "ellipse.h"
#include "memo.h"
#include "beschleunigung.h"
#include "f_linear.h"
#include "f_kreis.h"
#include "f_ellips.h"
#include "pcncdata.h"
#include "getcircle.h"
#include "wrp.h"
#include "frage.h"

class PCNCView : public M3Dansicht
	{
	Q_OBJECT
public:

	PCNCView( QWidget *parent );

	~PCNCView();

	Bohrung *Bo;
	Bohrloch_fasen *Bf;
	Bohrloch_versenken * Bv;
	Topfloch *To;
	Quader *Qu;
	Zylinder *Zy;
	Tasche *Ta;
	Gewinde *Gew;
	Text *Tx;
	MaschinenAuswahl *ma;
	WWechsel *w;
	WWechsel1 *w1;
	Linie *Li;
	Liniex *Lix;
	Liniey *Liy;
	Liniez *Liz;
	Kreis *Kr;
	Vorschub *Vrs;
	Schleife *S;
	Spiel *Sp;
	Werkzeugwechsel *Ww;
	Ellipse *El;
	Memo *M;
	Beschleunigung *B;
	F_Linear *FL;
	F_Kreis *FK;
	F_Ellips *FE;
	AWwahl *AWw;
	WRP *wrp_dialog;
	Frage *frage_dialog;


	KProcess *steur;
	KProcess *wtool;
	KProcess *mtool;

	QWidget *lastwidget_F, *lastwidget_right, *lastwidget_left;
	bool  OK, FIRST;
	int zeile, spalte, Wi, p, aW, aM, maschine, sidebar, min_timesteps;
	unsigned int mfaktor, n, m, f, sai, ssi, sei;
	double X, Y, Z, Time;
	QString s, werkzeug, line, dir, steuerprog, zeichendat;
	CircleData c1, e1;

	struct loop_t
		{
		bool CLAUSE;
		unsigned long start;
		unsigned long clause;
		} loop[255];

	struct frage_t
		{
		bool FRAGE;
		unsigned long start;
		unsigned long ziel;
		} frage[255];

	QString getEllips( uint, double, double, char*, double, char, double, double, char, double, double, CircleData* );
	int getcurrentpos( QTextEdit *editor, int , double*, double*, double*, double* );
	unsigned char getbits( int );
	unsigned char getuchar( int );
	unsigned short int getushort( int );
	unsigned short int getushort( int, int );
	long int getlong( int );
	unsigned long int getulong( int, uchar );
	int fitsin( double, double, double* );
	bool defAW( int* );
	void firstTool( int );
	void werkzeugwechsel( int );
	QWidget* showclicked( QWidget*, QWidget* );
	void quit_pcnc( QCloseEvent * );

signals:
	void signalChangeStatusbar( const QString& text );

public slots:
// Slots of PCNCView
	void read();
	void write();
	void writeto();
	void fileNew();
	void make_nc();
	void werkzeuge();
	void maschiene();
	void modified();

// Left Buttons
	void anfang_clicked();
	void bohrung_clicked();
	void bohrung_einfuegen_clicked();//   parentWidget()
	void fase_clicked();
	void fase_einfuegen_clicked();//   parentWidget()
	void versenken_clicked();
	void versenken_einfuegen_clicked();//   parentWidget()
	void topfloch_clicked();
	void topfloch_einfuegen_clicked();//   parentWidget()
	void zylinder_clicked();
	void zylinder_einfuegen_clicked(); // zylinder_durchmesser = new HistoryDoubleInput( 0.00, 180.00, 0.00, 0.02, 2, zylinder, "zylinder_durchmesser" )
	void quader_clicked();
	void quader_einfuegen_clicked();//   parentWidget()
	void tasche_clicked();
	void tasche_einfuegen_clicked();//   parentWidget()
	void gewinde_clicked();
	void gewinde_einfuegen_clicked();//   parentWidget()
	void text_clicked();
	void text_einfuegen_clicked();
	void kontur_button_clicked();
	void ende_clicked();

// Right Buttons
	void kreis_clicked();
	void liniez_clicked();
	void liniey_clicked();
	void liniex_clicked();
	void linie_clicked();
	void vorschub_clicked();
	void schleife_clicked();
	void spiel_clicked();
	void wechsel_clicked();
	void ellipse_clicked();
	void pause_clicked();
	void memo_clicked();
	void beschleunigung_clicked();
	void wrp_clicked();
	void springe_clicked();
	void frage_clicked();

// Function Buttons
	void f_linear_clicked();
	void f_ellipse_clicked();
	void f_kreis_clicked();

// Right Widgets edit directly:
	void kreis_einfuegen_clicked();//   parentWidget()
	void linie_einfuegen_clicked();
	void liniex_einfuegen_clicked();//   parentWidget()
	void liniey_einfuegen_clicked();//   parentWidget()
	void liniez_einfuegen_clicked();//   parentWidget()
	void vs_max_z_einfuegen_clicked();//   parentWidget()
	void vs_max_y_einfuegen_clicked();//   parentWidget()
	void vs_max_x_einfuegen_clicked();//   parentWidget()
	void vs_schlichten_einfuegen_clicked();//   parentWidget()
	void vs_bohren_einfuegen_clicked();//   parentWidget()
	void vs_eintauchen_einfuegen_clicked();//   parentWidget()
	void vs_normal_einfuegen_clicked();//   parentWidget()
	void schleif_grund_einfuegen_clicked();//   parentWidget()
	void schleif_anfang_einfuegen_clicked();//   parentWidget()
	void schleif_ende_einfuegen_clicked();//   parentWidget()
	void spiel_einfuegen_clicked();//   parentWidget()
	void wechsel_einfuegen_clicked();//   parentWidget()
	void ellipse_einfuegen_clicked();//   parentWidget()
	void memo_einfuegen_clicked();
	void beschleunigung_einfuegen_clicked();//   parentWidget()
	void wrp_einfuegen_clicked();
	void frage_einfuegen_clicked();
	void frage_einfuegen1_clicked();

// Function Widgets edit directly:
	void f_linear_einfuegen_clicked();//   parentWidget()
	void kreisfunktion_einfuegen_clicked();//   parentWidget()
	void deltakreis_einfuegen_clicked();//   parentWidget()
	void ellipsfunktion_einfuegen_clicked();//   parentWidget()
	void deltaellips_einfuegen_clicked();//   parentWidget()
	void z_auswahl_clicked();//   parentWidget()

private slots:
// PCNCView event
	void resizeEvent( QResizeEvent* );

	};

#endif // _PCNCVIEW_H_
