/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de
  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "strtonum.h"


unsigned long int StrToNum::StringToULong( QString &string, bool *ok, uchar precision )
	{
	unsigned long int li;
	uchar e;
	bool point;
	uchar n;

	e = string.length();
	li = 0;
	point = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				li = li * 10;
				break;
			case '1' :
				li = li * 10 + 1;
				break;
			case '2' :
				li = li * 10 + 2;
				break;
			case '3' :
				li = li * 10 + 3;
				break;
			case '4' :
				li = li * 10 + 4;
				break;
			case '5' :
				li = li * 10 + 5;
				break;
			case '6' :
				li = li * 10 + 6;
				break;
			case '7' :
				li = li * 10 + 7;
				break;
			case '8' :
				li = li * 10 + 8;
				break;
			case '9' :
				li = li * 10 + 9;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						return li;
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point ) for ( n = 0; n < precision; n++ ) li = li * 10;
	return li;
	}

signed long int StrToNum::StringToLong( QString &string, bool *ok, uchar precision )
	{
	long int li;
	uchar e;
	bool point, minus;
	uchar n;

	e = string.length();
	li = 0;
	point = FALSE;
	minus = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				li = li * 10;
				break;
			case '1' :
				li = li * 10 + 1;
				break;
			case '2' :
				li = li * 10 + 2;
				break;
			case '3' :
				li = li * 10 + 3;
				break;
			case '4' :
				li = li * 10 + 4;
				break;
			case '5' :
				li = li * 10 + 5;
				break;
			case '6' :
				li = li * 10 + 6;
				break;
			case '7' :
				li = li * 10 + 7;
				break;
			case '8' :
				li = li * 10 + 8;
				break;
			case '9' :
				li = li * 10 + 9;
				break;
			case '-' :
				if ( li != 0 )
					return li;
				minus = TRUE;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						{
						*ok *= FALSE;
						return 1;
						}
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point ) for ( n = 0; n < precision; n++ ) li = li * 10;
	if ( minus ) li = -li;
	return li;
	}

unsigned short int StrToNum::StringToUShort( QString &string, bool *ok, uchar precision )
	{
	unsigned short int si = 0;
	uchar e;
	bool point;
	uchar n;

	e = string.length();
	si = 0;
	point = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				si = si * 10;
				break;
			case '1' :
				si = si * 10 + 1;
				break;
			case '2' :
				si = si * 10 + 2;
				break;
			case '3' :
				si = si * 10 + 3;
				break;
			case '4' :
				si = si * 10 + 4;
				break;
			case '5' :
				si = si * 10 + 5;
				break;
			case '6' :
				si = si * 10 + 6;
				break;
			case '7' :
				si = si * 10 + 7;
				break;
			case '8' :
				si = si * 10 + 8;
				break;
			case '9' :
				si = si * 10 + 9;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						return si;
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point )
		for ( n = 0; n < precision; n++ )
			si = si * 10;
	return si;
	}

signed short int StrToNum::StringToShort( QString &string, bool *ok, uchar precision )
	{
	short int si = 0;
	uchar e;
	bool point, minus;
	uchar n;

	e = string.length();
	si = 0;
	point = FALSE;
	minus = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				si = si * 10;
				break;
			case '1' :
				si = si * 10 + 1;
				break;
			case '2' :
				si = si * 10 + 2;
				break;
			case '3' :
				si = si * 10 + 3;
				break;
			case '4' :
				si = si * 10 + 4;
				break;
			case '5' :
				si = si * 10 + 5;
				break;
			case '6' :
				si = si * 10 + 6;
				break;
			case '7' :
				si = si * 10 + 7;
				break;
			case '8' :
				si = si * 10 + 8;
				break;
			case '9' :
				si = si * 10 + 9;
				break;
			case '-' :
				if ( si != 0 )
					return si;
				minus = TRUE;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						{
						*ok *= FALSE;
						return 1;
						}
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point )
		for ( n = 0; n < precision; n++ )
			si = si * 10;
	if ( minus ) si = -si;
	return si;
	}

unsigned char StrToNum::StringToUChar( QString &string, bool *ok, uchar precision )
	{
	unsigned char ch;
	uchar e;
	bool point;
	uchar n;

	e = string.length();
	ch = 0;
	point = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				ch = ch * 10;
				break;
			case '1' :
				ch = ch * 10 + 1;
				break;
			case '2' :
				ch = ch * 10 + 2;
				break;
			case '3' :
				ch = ch * 10 + 3;
				break;
			case '4' :
				ch = ch * 10 + 4;
				break;
			case '5' :
				ch = ch * 10 + 5;
				break;
			case '6' :
				ch = ch * 10 + 6;
				break;
			case '7' :
				ch = ch * 10 + 7;
				break;
			case '8' :
				ch = ch * 10 + 8;
				break;
			case '9' :
				ch = ch * 10 + 9;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						return ch;
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point )
		for ( n = 0; n < precision; n++ )
			ch = ch * 10;
	return ch;
	}

signed char StrToNum::StringToChar( QString &string, bool *ok, uchar precision )
	{
	char ch;
	uchar e;
	bool point, minus;
	uchar n;

	e = string.length();
	ch = 0;
	point = FALSE;
	minus = FALSE;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
			case 0 :
				ch = ch * 10;
				break;
			case '1' :
				ch = ch * 10 + 1;
				break;
			case '2' :
				ch = ch * 10 + 2;
				break;
			case '3' :
				ch = ch * 10 + 3;
				break;
			case '4' :
				ch = ch * 10 + 4;
				break;
			case '5' :
				ch = ch * 10 + 5;
				break;
			case '6' :
				ch = ch * 10 + 6;
				break;
			case '7' :
				ch = ch * 10 + 7;
				break;
			case '8' :
				ch = ch * 10 + 8;
				break;
			case '9' :
				ch = ch * 10 + 9;
				break;
			case '-' :
				if ( ch != 0 )
					{
					*ok *= FALSE;
					return 0;
					}
				minus = TRUE;
				break;
			case '.' :
			case ',' :
				if ( ! point )
					{
					if ( precision == 0 )
						return ch;
					point = TRUE;
					e = n + precision + 1;
					break;
					}
				else
					{
					*ok *= FALSE;
					return 0;
					}
			default :
				*ok *= FALSE;
				return 0;
			}
		}
	if ( ! point )
		for ( n = 0; n < precision; n++ )
			ch = ch * 10;

	if ( minus ) ch = -ch;
	return ch;
	}

uchar StrToNum::StringbitsToUChar( QString &s, bool *ok )
	{
	uchar h, c;

	h = 128, c = 0;
	for ( int n = 0; n < 8; n++ )
		{
		if ( s.at( n ) == '0' )
			h = h / 2;
		else
			if ( s.at( n ) == '1' )
				{
				c = c + h;
				h = h / 2;
				}
			else
				{
				*ok *= FALSE;
				return 0;
				}
		}

	return c;
	}

/**
 * Returns the first occurance of a number in a sting as an unsigned integer or
 * -1 if the end is reached and no number found or
 * -2 if the number found doesn't fit into unsigned integer (32 bit).
 */

int StrToNum::getUInt( QString &string, bool *ok )
	{
	unsigned int i;
	uchar e, n, a;
	bool NUM;

	NUM = FALSE;
	e = string.length();
	i = 0;
	a = 0;
	for ( n = 0; n < e; n++ )
		{
		QChar c = string.at( n );
		switch ( c )
			{
			case '0' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a0				\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a0:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '1' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a11				\n\t"
				   "addl	$1,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a1				\n\t"
				   "a11:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a1:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '2' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a22				\n\t"
				   "addl	$2,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a2				\n\t"
				   "a22:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a2:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '3' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a33				\n\t"
				   "addl	$3,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a3				\n\t"
				   "a33:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a3:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '4' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a44				\n\t"
				   "addl	$4,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a4				\n\t"
				   "a44:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a4:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				a++;
				break;
			case '5' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a55				\n\t"
				   "addl	$5,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a5				\n\t"
				   "a55:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a5:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '6' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a66				\n\t"
				   "addl	$6,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a6				\n\t"
				   "a66:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a6:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '7' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a77				\n\t"
				   "addl	$7,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a7				\n\t"
				   "a77:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a7:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '8' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a88				\n\t"
				   "addl	$8,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a8				\n\t"
				   "a88:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a8:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			case '9' :
				asm volatile(
				   "movl	$10,%%eax		\n\t"
				   "mull	%2				\n\t"
				   "jc		a99				\n\t"
				   "addl	$1,%%eax			\n\t"
				   "movl	%%eax,%1		\n\t"
				   "jnc	a9				\n\t"
				   "a99:					\n\t"
				   "movb	$0,%0			\n\t"
				   "movl	$-3,%%eax		\n\t"
				   "lea	-0xc(%%ebp),%%esp	\n\t"
				   "pop	%%ebx			\n\t"
				   "pop	%%esi			\n\t"
				   "pop	%%edi			\n\t"
				   "pop	%%ebp			\n\t"
				   "ret						\n\t"
				   "a9:					\n\t"
			   : "=m"( ok ), "=m"( i )
						   : "m"( i ) );
				NUM = TRUE;
				break;
			default :
				if ( NUM )
					{
					*ok *= TRUE;
					return i;
					}
			}
		}

	if ( NUM )
		{
		*ok *= TRUE;
		return i;
		}

	*ok *= FALSE;
	return -1;
	}
