/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                    
  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "wwechsel1.h"

#include <qtabwidget.h>

#include "historydoubleinput.h"

WWechsel1::WWechsel1( QWidget *parent, const char *name )
   : Werkzeugwechsel1( parent, name )
	{
	}

WWechsel1::~WWechsel1()
	{
	}

double WWechsel1::d_x( double X )
	{
	if( basis->currentPageIndex() == 0 )
		{   // Relativ
		return dx->value();
		}
	else
		{   // Absolut
		return px->value() - X;
		}
	}

double WWechsel1::d_y( double Y )
	{
	if( basis->currentPageIndex() == 0 )
		{   // Relativ
		return dy->value();
		}
	else
		{   // Absolut
		return px->value() - Y;
		}
	}

double WWechsel1::d_z( double Z )
	{
	if( basis->currentPageIndex() == 0 )
		{   // Relativ
		return dz->value();
		}
	else
		{   // Absolut
		return px->value() - Z;
		}
	}


#include "wwechsel1.moc"
